'$DYNAMIC
'$INCLUDE: 'Future.Bi'
'$INCLUDE: 'flimpext.bi'

DECLARE FUNCTION IsFile (File$)
DECLARE FUNCTION LoadScript (File$)
DECLARE SUB KillScript (ScriptID)
DECLARE SUB RunScript ()
DECLARE SUB Parse ()
DECLARE SUB JumpToNext (PosName$)


DECLARE FUNCTION GetString$ (BYVAL start AS INTEGER, BYVAL Argument AS INTEGER)
DECLARE FUNCTION GetInteger (BYVAL start AS INTEGER, BYVAL Argument AS INTEGER)
DECLARE FUNCTION GetDouble# (BYVAL start AS INTEGER, BYVAL Argument AS INTEGER)

DECLARE FUNCTION GetStrValue$ (StringName$)
DECLARE FUNCTION GetIntValue (IntegerName$)
DECLARE FUNCTION GetDoubleValue# (DoubleName$)

DECLARE SUB SetString (StringName$, Value$)
DECLARE SUB SetInteger (StringName$, BYVAL Value AS INTEGER)
DECLARE SUB SetDouble (StringName$, BYVAL Value AS DOUBLE)

DECLARE FUNCTION ReadINFFile$ (FileName$, SearchFor$)

CONST NofS = 25   ' Number of Scripts to run (Can be up to 255)
CONST True = -1
CONST False = 0
CONST Ver = "0.8i:0.4c"
TYPE ScriptVariables
   Status            AS INTEGER
   Pos               AS INTEGER
   FileName          AS STRING * 12
   TextFCol          AS LONG
   TextBCol          AS LONG
   begin             AS INTEGER
   ReturnPoint(10)   AS INTEGER
   ReturnCount       AS INTEGER
   TextXLoc          AS INTEGER
   TextYLoc          AS INTEGER
   WinID             AS INTEGER
END TYPE
TYPE StringVariables
   Name     AS STRING * 10
   ScriptID AS INTEGER
END TYPE
TYPE IntegerVariables
   Name     AS STRING * 10
   Value    AS INTEGER
   ScriptID AS INTEGER
END TYPE
TYPE DoubleVariables
   Name     AS STRING * 10
   Value    AS DOUBLE
   ScriptID AS INTEGER
END TYPE

COMMON SHARED /ScriptEngine/ ScriptCount, ActiveScript, Argument
COMMON SHARED /SctiptEngine/ MarkPos, RunScriptNr, SemiColon, TempSegment
COMMON SHARED /ScriptEngine/ Script()     AS ScriptVariables
COMMON SHARED /ScriptEngine/ Cmd()        AS STRING

COMMON SHARED /ScriptVariables/ IntVar()  AS IntegerVariables
COMMON SHARED /ScriptVariables/ DblVar()  AS DoubleVariables
COMMON SHARED /ScriptVariables/ StrVar()  AS StringVariables
COMMON SHARED /ScriptVariables/ StrVal()  AS STRING
COMMON SHARED /ScriptVariables/ IntegerCount, StringCount, DoubleCount

CONST NofW = 25
CONST NofO = 500
TYPE WinVariables
   Xpos     AS INTEGER
   Ypos     AS INTEGER
   X1pos    AS INTEGER
   Y1pos    AS INTEGER
   XSize    AS INTEGER
   YSize    AS INTEGER
   ID       AS INTEGER
   Status   AS INTEGER
   Caption  AS STRING * 20
   Mask     AS INTEGER
END TYPE
TYPE RGBTable
   Red      AS INTEGER
   Green    AS INTEGER
   Blue     AS INTEGER
END TYPE
TYPE ButtonVariables
   XSize    AS INTEGER
   YSize    AS INTEGER
   Status   AS INTEGER
   ObjectID AS INTEGER
   Style    AS INTEGER
END TYPE
TYPE ObjectVariables
   Xpos     AS INTEGER
   Ypos     AS INTEGER
   X1pos    AS INTEGER
   Y1pos    AS INTEGER
   Type     AS INTEGER
   ObjectID AS INTEGER
   WinID    AS INTEGER
END TYPE

DECLARE FUNCTION New.Window% (Xpos, Ypos, XSize, YSize, Caption$)
DECLARE FUNCTION GetColor& (Number%)
DECLARE FUNCTION GetStyleColor& (Style%, Number%)
DECLARE FUNCTION DetectWin ()
DECLARE SUB SetActiveWin (WinID%)
DECLARE SUB InitGui (BYVAL InitXres AS INTEGER, BYVAL InitYres AS INTEGER, BYVAL InitDeph AS INTEGER)
DECLARE SUB RunGui ()
DECLARE SUB CloseGui ()
DECLARE SUB ChangePage ()
DECLARE SUB Draw.Window (Xpos, Ypos, X1pos, Y1pos, Title$, Style)
DECLARE SUB Draw.Button (ButID, WinID)
DECLARE FUNCTION New.Button% (Xpos, Ypos, XSize, YSize, Caption$, Style, WinID)

COMMON SHARED /Gui.System/ Xres, Yres, Deph, Initalised
COMMON SHARED /Gui.System/ VisPage, WrkPage, DesktopMask
COMMON SHARED /Gui.System/ MouseX, MouseY, MouseB, OldMouseX, OldMouseY
COMMON SHARED /Gui.System/ MouseOnWin, MouseOnWinX, MouseOnWinY, MouseChanged
COMMON SHARED /Gui.System/ Process, ProcessID, ProcessTemp, ProcessTempID
COMMON SHARED /Gui.Window/ MoveTempX, MoveTempY, MoveTempX1, MoveTempY1
COMMON SHARED /Gui.Window/ MoveTemp1, MoveTemp2, MoveTemp3, MoveTemp4
COMMON SHARED /Gui.Window/ WinCount, ActiveWin
COMMON SHARED /Gui.Window/ Win()       AS WinVariables
COMMON SHARED /Gui.Window/ WinOrder()  AS INTEGER
COMMON SHARED /Gui.Object/ Object()    AS ObjectVariables
COMMON SHARED /Gui.Button/ Button()    AS ButtonVariables
COMMON SHARED /Gui.Button/ ButText()   AS STRING
COMMON SHARED /Gui.Button/ ButtonCount


DIM SHARED Cmd(12) AS STRING
DIM SHARED cmdLine AS STRING
DIM SHARED Object(NofO)    AS ObjectVariables
DIM SHARED Win(NofW)       AS WinVariables
DIM SHARED WinOrder(NofW)  AS INTEGER
CALL Ffix
CLS
IF COMMAND$ > "" THEN
   ToLoad$ = COMMAND$
ELSE
   LINE INPUT "Please enter File name to load: "; ToLoad$
'ToLoad$ = "shell.txt"
END IF

Scr1 = LoadScript(ToLoad$)
IF Scr1 = 0 THEN
   PRINT "Error: File not found or is corrupted"
   PRINT "Press any key to exit"
   SLEEP
   SYSTEM
END IF
DO
   RunScript
   IF Initalised = True THEN
      DO
         RunScript
         RunGui
      LOOP UNTIL Initalised = False
   END IF
LOOP
CloseGui
CLEAR
CLOSE

REM $STATIC
SUB ChangePage
SWAP WrkPage, VisPage
viewPage VisPage
END SUB

SUB CloseGui
DeallocateXMS DesktopMask
FOR Count = 1 TO WinCount
   IF Win(Count).Status <> 0 THEN
      DeallocateXMS Win(Count).Mask
   END IF
NEXT
Future.MouseOFF
ReSetScreen
Initalised = False
END SUB

FUNCTION DetectWin
FOR SearchWin = WinCount TO 1 STEP -1
   WinID = WinOrder(SearchWin)
   IF MouseX > Win(WinID).Xpos THEN
      IF MouseX < Win(WinID).X1pos THEN
         IF MouseY > Win(WinID).Ypos THEN
            IF MouseY < Win(WinID).Y1pos THEN
               DetectWin = WinID
               MouseOnWinX = MouseX - Win(WinID).Xpos
               MouseOnWinY = MouseY - Win(WinID).Ypos
               EXIT FUNCTION
            END IF
         END IF
      END IF
   END IF
NEXT
END FUNCTION

SUB Draw.Button (ButID, WinID)
WinX = Win(WinID).Xpos
WinY = Win(WinID).Ypos
Xpos = Object(Button(ButID).ObjectID).Xpos + WinX
Ypos = Object(Button(ButID).ObjectID).Ypos + WinY
X1pos = Object(Button(ButID).ObjectID).X1pos + WinX
Y1pos = Object(Button(ButID).ObjectID).Y1pos + WinY
XSize = Button(ButID).XSize
YSize = Button(ButID).YSize
Colr = Button(ButID).Style
Status = Button(ButID).Status
Title$ = ButText(ButID)

Future.MouseOFF
Future.FillBox Xpos + 1, Ypos + 1, X1pos - 1, Y1pos - 1, GetStyleColor(Colr, 1)
IF Status = 1 THEN
   Future.Box Xpos, Ypos, X1pos, Y1pos, GetStyleColor(Colr, 2)
   Future.Line X1pos, Ypos, X1pos, Y1pos, GetStyleColor(Colr, 3), -1
   Future.Line Xpos, Y1pos, X1pos, Y1pos, GetStyleColor(Colr, 3), -1
   TextX = Xpos + (XSize / 2 - LEN(Title$) * 4)
   TextY = Ypos + (YSize / 2 - 7)
   Future.Print TextX, TextY, Title$, 0, -1
ELSE
   Future.Box Xpos, Ypos, X1pos, Y1pos, GetStyleColor(Colr, 3)
   Future.Line X1pos, Ypos, X1pos, Y1pos, GetStyleColor(Colr, 2), -1
   Future.Line Xpos, Y1pos, X1pos, Y1pos, GetStyleColor(Colr, 2), -1
   TextX = Xpos + (XSize / 2 - LEN(Title$) * 4) + 1
   TextY = Ypos + (YSize / 2 - 7) + 1
   Future.Print TextX, TextY, Title$, 0, -1
END IF
Future.MouseON
END SUB

SUB Draw.Window (Xpos, Ypos, X1pos, Y1pos, Title$, Style)
Future.FillBox Xpos, Ypos, X1pos, Ypos + 17, GetStyleColor(Style, 1)
Future.Box Xpos + 1, Ypos + 19, X1pos - 1, Y1pos - 1, GetStyleColor(Style, 1)
Future.Box Xpos, Ypos, X1pos - 1, Ypos + 17, GetStyleColor(Style, 2)
Future.Box Xpos, Ypos + 18, X1pos, Y1pos, GetStyleColor(Style, 2)

Future.Box Xpos + 1, Ypos + 1, X1pos, Ypos + 18, GetStyleColor(Style, 3)
Future.PSET Xpos, Ypos + 18, GetStyleColor(Style, 3)
Future.Line Xpos, Y1pos, X1pos, Y1pos, GetStyleColor(Style, 3), -1
Future.Line X1pos, Ypos, X1pos, Y1pos, GetStyleColor(Style, 3), -1

TextX = Xpos + ((X1pos - Xpos) / 2) - (LEN(Title$) * 4)
TextY = Ypos + 1
Future.Print TextX + 1, TextY + 1, Title$, 0, -1
Future.Print TextX, TextY, Title$, RGB2Color(200, 200, 200), -1
END SUB

FUNCTION GetColor& (Number)
IF Deph = 8 OR Number < 1 THEN GetColor& = Number: EXIT FUNCTION
DIM RGB AS RGBTable
RGBTableFile = FREEFILE
OPEN "data\8bit.Wgd" FOR RANDOM ACCESS READ AS #RGBTableFile LEN = 6
   GET #RGBTableFile, Number + 1, RGB
   GetColor& = RGB2Color(RGB.Red, RGB.Green, RGB.Blue)
CLOSE #RGBTableFile
END FUNCTION

FUNCTION GetDouble# (BYVAL start AS INTEGER, BYVAL Argument AS INTEGER)
'Calculates Double expression value.
   FOR argCount = start TO Argument
      SELECT CASE Cmd(argCount)
      CASE "+"
         Action = 0
      CASE "-"
         Action = 1
      CASE "*"
         Action = 2
      CASE "/", "mod"
         Action = 3
      CASE "val"
         TempVal# = VAL(GetString$(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "abs"
         TempVal# = ABS(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "sgn"
         TempVal# = SGN(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "atn"
         TempVal# = ATN(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "cos"
         TempVal# = COS(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "sin"
         TempVal# = SIN(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "tan"
         TempVal# = TAN(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "log"
         TempVal# = LOG(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "exp"
         TempVal# = EXP(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "sqr"
         TempVal# = SQR(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "fix"
         TempVal# = FIX(GetDouble(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE ELSE
         IF RIGHT$(Cmd(argCount), 1) = "#" THEN
            TempVal# = GetDoubleValue(Cmd(argCount))
         ELSE
            SELECT CASE Cmd(argCount)
            CASE CHR$(48) TO CHR$(57)
               TempVal# = VAL(Cmd(argCount))
            CASE ELSE
               TempVal# = CDBL(GetInteger(argCount, Argument))
            END SELECT
         END IF
      END SELECT
      SELECT CASE Action
      CASE 0
         Temp# = Temp# + TempVal#
      CASE 1
         Temp# = Temp# - TempVal#
      CASE 2
         IF TempVal# <> 0 THEN
            Temp# = Temp# * TempVal#
         END IF
      CASE 3
         IF TempVal# <> 0 THEN
            Temp# = Temp# / TempVal#
         END IF
      END SELECT
      TempVal# = 0
   NEXT
   GetDouble# = Temp#
END FUNCTION

FUNCTION GetDoubleValue# (DoubleName$)
'Finds and returns Double type variable value
FOR VarSearch = 1 TO DoubleCount
   IF DblVar(VarSearch).ScriptID = ActiveScript THEN
      IF DoubleName$ = RTRIM$(DblVar(VarSearch).Name) THEN
         GetDoubleValue# = DblVar(VarSearch).Value
         EXIT FUNCTION
      END IF
   END IF
NEXT VarSearch
DoubleCount = DoubleCount + 1
REDIM PRESERVE DblVar(DoubleCount) AS DoubleVariables
DblVar(DoubleCount).Name = DoubleName$
DblVar(DoubleCount).Value = 0
DblVar(DoubleCount).ScriptID = ActiveScript
END FUNCTION

FUNCTION GetInteger (BYVAL start AS INTEGER, BYVAL Argument AS INTEGER)
'Calculates integer expression value.
   FOR argCount = start TO Argument
      SELECT CASE Cmd(argCount)
      CASE "+"
         Action = 0
      CASE "-"
         Action = 1
      CASE "*"
         Action = 2
      CASE "/", "mod"
         Action = 3
      CASE "asc"
         TempVal = ASC(GetString$(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "len"
         SELECT CASE RIGHT$(Cmd(argCount + 1), 1)
         CASE CHR$(34), "$"
            TempVal = LEN(GetString$(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE ELSE
            Temp = GetInteger(argCount + 1, argCount + 1)
            TempVal = LEN(Temp)
            argCount = argCount + 1
         END SELECT
      CASE "val"
         TempVal = VAL(GetString$(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "rnd"
         TempVal = INT(RND * GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "freefile"
         TempVal = FREEFILE
      CASE "procstatus"
         TempVal = Script(GetInteger(argCount + 1, argCount + 1)).Status
         argCount = argCount + 1
      CASE "varseg"
         Temp = GetInteger(argCount + 1, argCount + 1)
         TempVal = VARSEG(Temp)
         argCount = argCount + 1
      CASE "varptr"
         Temp = GetInteger(argCount + 1, argCount + 1)
         TempVal = VARPTR(Temp)
         argCount = argCount + 1
      CASE "peek"
         Temp = GetInteger(argCount + 1, argCount + 1)
         TempVal = PEEK(Temp)
         argCount = argCount + 1
      CASE "sseg"
         Temp$ = GetString$(argCount + 1, argCount + 1)
         TempVal = SSEG(Temp$)
         argCount = argCount + 1
      CASE "ssad"
         Temp$ = GetString$(argCount + 1, argCount + 1)
         TempVal = SADD(Temp$)
         argCount = argCount + 1
      CASE "ssegadd"
         Temp$ = GetString$(argCount + 1, argCount + 1)
         TempVal = SSEGADD(Temp$)
         argCount = argCount + 1
      CASE "fre"
         SELECT CASE RIGHT$(Cmd(argCount + 1), 1)
         CASE CHR$(34), "$"
            TempVal = FRE(GetString$(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE ELSE
            TempVal = FRE(GetString(argCount + 1, argCount + 1))
            argCount = argCount + 1
         END SELECT
      CASE "inp"
         Temp = GetInteger(argCount + 1, argCount + 1)
         TempVal = PEEK(Temp)
         argCount = argCount + 1
      CASE "csrlin"
         TempVal = CSRLIN
      CASE "pos"
         TempVal = POS(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "instr"
         TempVal = INSTR(GetInteger(argCount + 1, argCount + 1), GetString(argCount + 2, argCount + 2), GetString(argCount + 3, argCount + 3))
         argCount = argCount + 3
      CASE "abs"
         TempVal = ABS(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "sgn"
         TempVal = SGN(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "atn"
         TempVal = ATN(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "cos"
         TempVal = COS(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "sin"
         TempVal = SIN(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "tan"
         TempVal = TAN(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "log"
         TempVal = LOG(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "exp"
         TempVal = EXP(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "sqr"
         TempVal = SQR(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "fix"
         TempVal = FIX(GetInteger(argCount + 1, argCount + 1))
         argCount = argCount + 1
      CASE "event"
         IF ProcessTemp > 0 THEN
            TempVal = ProcessTemp
         END IF
      CASE "eventid"
         TempVal = ProcessTempID
      CASE "activewin"
         TempVal = ActiveWin
      CASE "initalised"
         TempVal = Initalised
      CASE ELSE
         IF RIGHT$(Cmd(argCount), 1) = "%" THEN
            TempVal = GetIntValue(Cmd(argCount))
         ELSE
            TempVal = VAL(Cmd(argCount))
         END IF
      END SELECT
      SELECT CASE Action
      CASE 0
         Temp = Temp + TempVal
      CASE 1
         Temp = Temp - TempVal
      CASE 2
         IF TempVal <> 0 THEN
            Temp = Temp * TempVal
         END IF
      CASE 3
         IF TempVal <> 0 THEN
            Temp = Temp / TempVal
         END IF
      END SELECT
      TempVal = 0
   NEXT
   GetInteger = Temp
   EXIT FUNCTION
END FUNCTION

FUNCTION GetIntValue (IntName$)
'Finds and returns Integer type variable value
FOR VarSearch = 1 TO IntegerCount
   IF IntVar(VarSearch).ScriptID = ActiveScript THEN
      IF IntName$ = RTRIM$(IntVar(VarSearch).Name) THEN
         GetIntValue = IntVar(VarSearch).Value
         EXIT FUNCTION
      END IF
   END IF
NEXT VarSearch
IntegerCount = IntegerCount + 1
REDIM PRESERVE IntVar(IntegerCount) AS IntegerVariables
IntVar(IntegerCount).Name = IntName$
IntVar(IntegerCount).Value = 0
IntVar(IntegerCount).ScriptID = ActiveScript
END FUNCTION

FUNCTION GetString$ (BYVAL start AS INTEGER, BYVAL Argument AS INTEGER)
'Calculates String Expression value
   FOR argCount = start TO Argument
      DetectType$ = RIGHT$(Cmd(argCount), 1)
      SELECT CASE DetectType$
      CASE CHR$(34)
         Temp$ = Temp$ + MID$(Cmd(argCount), 2, LEN(Cmd(argCount)) - 2)
      CASE "$"
         SELECT CASE Cmd(argCount)
         CASE "chr$"
            Temp$ = Temp$ + CHR$(GetInteger(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE "inkey$"
            Temp$ = Temp$ + INKEY$
         CASE "time$"
            Temp$ = Temp$ + TIME$
         CASE "date$"
            Temp$ = Temp$ + DATE$
         CASE "left$"
            Temp$ = LEFT$(GetString$(argCount + 1, argCount + 1), GetInteger(argCount + 2, argCount + 2))
            argCount = argCount + 2
         CASE "right$"
            Temp$ = RIGHT$(GetString$(argCount + 1, argCount + 1), GetInteger(argCount + 2, argCount + 2))
            argCount = argCount + 2
         CASE "mid$"
            Temp$ = MID$(GetString$(argCount + 1, argCount + 1), GetInteger(argCount + 2, argCount + 2), GetInteger(argCount + 3, argCount + 3))
            argCount = argCount + 3
         CASE "lcase$"
            Temp$ = Temp$ + LCASE$(GetString(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE "ucase$"
            Temp$ = Temp$ + UCASE$(GetString(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE "str$"
            IF RIGHT$(STR$(GetInteger(argCount + 1, argCount + 1)), 1) = "%" THEN
               Temp$ = Temp$ + STR$(GetInteger(argCount + 1, argCount + 1))
            ELSE
               Temp$ = Temp$ + STR$(GetDouble(argCount + 1, argCount + 1))
            END IF
            argCount = argCount + 1
         CASE "ver$"
            Temp$ = Temp$ + Ver
         CASE "string$"
            Temp$ = Temp$ + STRING$(GetInteger(argCount + 1, argCount + 1), GetString(argCount + 2, argCount + 2))
            argCount = argCount + 2
         CASE "readinf$"
            PRINT Cmd(argCount + 2)
            Temp$ = Temp$ + ReadINFFile$(GetString(argCount + 1, argCount + 1), GetString(argCount + 2, argCount + 2))
            argCount = argCount + 2
         CASE "hex$"
            Temp$ = Temp$ + HEX$(GetInteger(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE "oct$"
            Temp$ = Temp$ + OCT$(GetInteger(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE "ltrim$"
            Temp$ = Temp$ + LTRIM$(GetString(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE "rtrim$"
            Temp$ = Temp$ + RTRIM$(GetString(argCount + 1, argCount + 1))
            argCount = argCount + 1
         CASE ELSE
            Temp$ = Temp$ + GetStrValue$(Cmd(argCount))
         END SELECT
      END SELECT
   NEXT
   GetString$ = Temp$
   EXIT FUNCTION
END FUNCTION

FUNCTION GetStrValue$ (StringName$)
'find and returns String type variable value
FOR VarSearch = 1 TO StringCount
   IF StrVar(VarSearch).ScriptID = ActiveScript THEN
      IF StringName$ = RTRIM$(StrVar(VarSearch).Name) THEN
         GetStrValue$ = StrVal(VarSearch)
         EXIT FUNCTION
      END IF
   END IF
NEXT VarSearch
StringCount = StringCount + 1
REDIM PRESERVE StrVar(StringCount)  AS StringVariables
REDIM PRESERVE StrVal(StringCount)  AS STRING
StrVar(StringCount).Name = StringName$
StrVal(StringCount) = ""
StrVar(StringCount).ScriptID = ActiveScript
END FUNCTION

FUNCTION GetStyleColor& (Style%, Number%)
SELECT CASE Style%
   CASE 1
      IF Number% = 1 THEN GetStyleColor& = RGB2Color(152, 132, 92)
      IF Number% = 2 THEN GetStyleColor& = RGB2Color(212, 188, 148)
      IF Number% = 3 THEN GetStyleColor& = RGB2Color(104, 80, 44)
   CASE 2
      IF Number% = 1 THEN GetStyleColor& = RGB2Color(132, 132, 132)
      IF Number% = 2 THEN GetStyleColor& = RGB2Color(168, 168, 168)
      IF Number% = 3 THEN GetStyleColor& = RGB2Color(100, 100, 100)
   CASE 3
      IF Number% = 1 THEN GetStyleColor& = RGB2Color(100, 100, 136)
      IF Number% = 2 THEN GetStyleColor& = RGB2Color(172, 172, 192)
      IF Number% = 3 THEN GetStyleColor& = RGB2Color(64, 64, 100)
   CASE 4
      IF Number% = 1 THEN GetStyleColor& = RGB2Color(104, 124, 76)
      IF Number% = 2 THEN GetStyleColor& = RGB2Color(152, 176, 108)
      IF Number% = 3 THEN GetStyleColor& = RGB2Color(60, 88, 48)
   CASE 5
      IF Number% = 1 THEN GetStyleColor& = RGB2Color(224, 0, 0)
      IF Number% = 2 THEN GetStyleColor& = RGB2Color(252, 100, 88)
      IF Number% = 3 THEN GetStyleColor& = RGB2Color(160, 0, 0)
   CASE 6
      IF Number% = 1 THEN GetStyleColor& = RGB2Color(80, 140, 160)
      IF Number% = 2 THEN GetStyleColor& = RGB2Color(156, 204, 220)
      IF Number% = 3 THEN GetStyleColor& = RGB2Color(40, 96, 120)
END SELECT
END FUNCTION

SUB InitGui (BYVAL InitXres AS INTEGER, BYVAL InitYres AS INTEGER, BYVAL InitDeph AS INTEGER)
SetMMX 1
Xres = InitXres
Yres = InitYres
Deph = InitDeph
WrkPage = 0
VisPage = 1

SetScreenMode InitXres, InitYres, InitDeph
SetPage WrkPage
viewPage VisPage
Future.CLS 0
DesktopMask = AllocateXMS(SizeOf(Xres, Yres))
SetLocation Xres / 2, Yres / 2
Process = 1
Initalised = True
END SUB

FUNCTION IsFile (File$)
'Check's if requested file exist.
'IF yes THEN returns True(-1) ELSE returns False(0)
IsFile = LEN(DIR$(File$)) > 0
END FUNCTION

SUB JumpToNext (PosName$)
TempPos = SEEK(ActiveScript)
DO
   LINE INPUT #ActiveScript, Temp$
   Temp$ = LTRIM$(RTRIM$(LCASE$(Temp$)))
   SELECT CASE PosName$
   CASE "end if"
      IF LEFT$(Temp$, 6) = "end if" THEN
         IF ToSkip = 0 THEN
            EXIT SUB
         ELSE
            ToSkip = ToSkip - 1
         END IF
      END IF
      IF LEFT$(Temp$, 2) = "if" THEN
         ToSkip = ToSkip + 1
      END IF
   CASE "loop"
      IF LEFT$(Temp$, 4) = "loop" THEN
         IF ToSkip = 0 THEN
            EXIT SUB
         ELSE
            ToSkip = ToSkip - 1
         END IF
      END IF
      IF LEFT$(Temp$, 2) = "do" THEN
         ToSkip = ToSkip + 1
      END IF
   CASE "next"
      IF LEFT$(Temp$, 4) = "next" THEN
         IF ToSkip = 0 THEN
            EXIT SUB
         ELSE
            ToSkip = ToSkip - 1
         END IF
      END IF
      IF LEFT$(Temp$, 3) = "for" THEN
         ToSkip = ToSkip + 1
      END IF
   CASE "end select"
      IF LEFT$(Temp$, 10) = "end select" THEN
         IF ToSkip = 0 THEN
            EXIT SUB
         ELSE
            ToSkip = ToSkip - 1
         END IF
      END IF
      IF LEFT$(Temp$, 6) = "select" THEN
         ToSkip = ToSkip + 1
      END IF
   END SELECT
LOOP UNTIL EOF(ActiveScript)
SEEK #ActiveScript, TempPos
END SUB

SUB KillScript (ScriptID)

END SUB

FUNCTION LoadScript (File$)
'Check for Errors
 IF ScriptCount = NofS THEN EXIT FUNCTION
 IF IsFile(File$) = False OR File$ = "" THEN EXIT FUNCTION

'Set up Variables
 ScriptCount = FREEFILE
 REDIM PRESERVE Script(ScriptCount) AS ScriptVariables
 Script(ScriptCount).Status = True
 Script(ScriptCount).TextFCol = 7
 Script(ScriptCount).TextBCol = 0

 'Open File
 OPEN File$ FOR INPUT AS #ScriptCount
 TmpFN$ = "Temp" + LTRIM$(STR$(ScriptCount)) + ".tmp"
 TmpFile = FREEFILE
 OPEN "temp\" + TmpFN$ FOR OUTPUT AS TmpFile
 Script(ScriptCount).FileName = TempFN$
 DO
   LINE INPUT #ScriptCount, Temp$
   Temp$ = LCASE$(LTRIM$(RTRIM$(Temp$)))
   PRINT #TmpFile, Temp$
 LOOP UNTIL EOF(ScriptCount)
 CLOSE TmpFile
 CLOSE ScriptCount
 OPEN "temp\" + TmpFN$ FOR INPUT AS #ScriptCount

'Read Scrpit Header, load variables
 DO
    Argument = 1
    Check = 0
    'REDIM Cmd(1) AS STRING
    LINE INPUT #ScriptCount, cmdLine$
    cmdLine$ = RTRIM$(LTRIM$(LCASE$(cmdLine$)))
    IF LEFT$(cmdLine$, 3) <> "rem" AND cmdLine$ > "" THEN
       DO
          Check = INSTR(cmdLine$, " ")
          IF Check > 0 THEN
             Cmd(Argument) = LEFT$(cmdLine$, Check - 1)
             cmdLine$ = RIGHT$(cmdLine$, LEN(cmdLine$) - Check)
             Argument = Argument + 1
             'REDIM PRESERVE Cmd(Argument) AS STRING
          ELSE
             Cmd(Argument) = cmdLine$
             EXIT DO
          END IF
       LOOP
       SELECT CASE Cmd(1)
          CASE "dim"
             SELECT CASE Cmd(4)
             CASE "integer"
                IntegerCount = IntegerCount + 1
                REDIM PRESERVE IntVar(IntegerCount) AS IntegerVariables
                IF RIGHT$(Cmd(2), 1) <> "%" THEN Cmd(2) = Cmd(2) + "%"
                IntVar(IntegerCount).Name = Cmd(2)
                IntVar(IntegerCount).Value = 0
                IntVar(IntegerCount).ScriptID = ScriptCount
             CASE "double"
                DoubleCount = DoubleCount + 1
                REDIM PRESERVE DblVar(DoubleCount) AS DoubleVariables
                IF RIGHT$(Cmd(2), 1) <> "#" THEN Cmd(2) = Cmd(2) + "#"
                DblVar(DoubleCount).Name = Cmd(2)
                DblVar(DoubleCount).Value = 0
                DblVar(DoubleCount).ScriptID = ScriptCount
             CASE "string"
                StringCount = StringCount + 1
                REDIM PRESERVE StrVar(StringCount)  AS StringVariables
                REDIM PRESERVE StrVal(StringCount)  AS STRING
                IF RIGHT$(Cmd(2), 1) <> "$" THEN Cmd(2) = Cmd(2) + "$"
                StrVar(StringCount).Name = Cmd(2)
                StrVal(StringCount) = ""
                StrVar(StringCount).ScriptID = ScriptCount
             END SELECT
          CASE "begin"
             EXIT DO
       END SELECT
    END IF
 LOOP
'Exit Script loader
 LoadScript = ScriptCount
 Script(ScriptCount).begin = SEEK(ScriptCount)

END FUNCTION

FUNCTION New.Button% (Xpos, Ypos, XSize, YSize, Caption$, Style, WinID)
IF Win(WinID).Status <> 2 THEN EXIT FUNCTION
FOR FreeSlot = 1 TO NofO
   IF Object(FreeSlot).Type = 0 THEN
      ObjectID = FreeSlot
      EXIT FOR
   END IF
NEXT
IF ObjectID = 0 THEN EXIT FUNCTION

FOR FreeSlot = 1 TO ButtonCount
   IF Button(FreeSlot).Status = 0 THEN
      ButID = FreeSlot
      EXIT FOR
   END IF
NEXT
IF ButID = 0 THEN
   ButtonCount = ButtonCount + 1
   ButID = ButtonCount
   REDIM PRESERVE Button(ButtonCount) AS ButtonVariables
   REDIM PRESERVE ButText(ButtonCount) AS STRING
END IF

'Set Object Variables
Object(ObjectID).Xpos = Xpos
Object(ObjectID).Ypos = Ypos
Object(ObjectID).X1pos = Xpos + XSize
Object(ObjectID).Y1pos = Ypos + YSize
Object(ObjectID).Type = 1
Object(ObjectID).ObjectID = ButID
Object(ObjectID).WinID = WinID

'Set Button Variables
Button(ButID).XSize = XSize
Button(ButID).YSize = YSize
Button(ButID).Status = 1
Button(ButID).ObjectID = ObjectID
Button(ButID).Style = Style
ButText(ButID) = Caption$

New.Button% = ButID
Draw.Button ButID, WinID
END FUNCTION

FUNCTION New.Window% (Xpos, Ypos, XSize, YSize, Caption$)
IF NofW <= WinCount THEN EXIT FUNCTION
FOR i = 1 TO NofW
   IF Win(i).Status = 0 THEN
      WinID = i
      EXIT FOR
   END IF
NEXT
WinCount = WinCount + 1
New.Window = WinID

Win(WinID).Xpos = Xpos
Win(WinID).Ypos = Ypos
Win(WinID).X1pos = Xpos + XSize
Win(WinID).Y1pos = Ypos + YSize
Win(WinID).XSize = XSize
Win(WinID).YSize = YSize
Win(WinID).Caption = Caption$
Win(WinID).Status = 2
Win(WinID).Mask = AllocateXMS(SizeOf(XSize, YSize))
WinOrder(WinCount) = WinID
IF ActiveWin > 0 THEN SetActiveWin 0
Future.FillBox Xpos + 2, Ypos + 19, Xpos + XSize - 2, Ypos + YSize - 2, RGB2Color(132, 132, 132)
Future.XMSget Xpos + 2, Ypos + 19, Xpos + XSize - 2, Ypos + YSize - 2, Win(WinID).Mask
SetActiveWin WinID
Future.MouseON
END FUNCTION

SUB Parse
Offset = SADD(cmdLine)
DEF SEG = SSEG(cmdLine)
DO
   Length = LEN(cmdLine)
   FOR SearchToken = 1 TO Length
      SELECT CASE PEEK(SearchToken + Offset - 1)
      CASE 32, 40, 41
         TokenPos = SearchToken - 1
         Check = SearchToken + 1
         Cmd(Argument) = LEFT$(cmdLine$, TokenPos)
         EXIT FOR
      CASE 44
         TokenPos = SearchToken - 1
         Check = SearchToken + 2
         Cmd(Argument) = LEFT$(cmdLine$, TokenPos)
         EXIT FOR
      CASE 34
         SearchToken = INSTR(2, cmdLine$, CHR$(34))
         TokenPos = SearchToken
         Check = SearchToken + 2
         Cmd(Argument) = LEFT$(cmdLine$, TokenPos)
         EXIT FOR
      CASE 60 TO 62
         MarkPos = Argument
      CASE 123
         RunScriptNr = ActiveScript
         cmdLine = MID$(cmdLine, 2)
      CASE 125
         RunScriptNr = 0
         IF SearchToken > 1 THEN
            TokenPos = SearchToken - 1
            Cmd(Argument) = LEFT$(cmdLine$, TokenPos)
         END IF
      CASE 59
         TokenPos = SearchToken - 1
         Check = SearchToken + 1
         Cmd(Argument) = LEFT$(cmdLine$, TokenPos)
         SemiColon = True
      CASE 39
         TokenPos = SearchToken - 1
         Cmd(Argument) = LEFT$(cmdLine$, TokenPos + 1)
         EXIT SUB
      END SELECT
   NEXT
   IF Check > 0 THEN
      cmdLine$ = LTRIM$(MID$(cmdLine$, Check))
      Argument = Argument + 1
      TokenPos = 0
      Check = 0
   ELSE
      Cmd(Argument) = cmdLine$
      IF TempSegment > 0 THEN DEF SEG = TempSegment
      EXIT SUB
   END IF
LOOP
END SUB

FUNCTION ReadINFFile$ (FileName$, SearchFor$)
IF NOT (IsFile(FileName$)) THEN EXIT FUNCTION
SearchFor$ = LCASE$(SearchFor$)
SFL = LEN(SearchFor$)
InfFile = FREEFILE
OPEN FileName$ FOR INPUT AS #InfFile

DO
   LINE INPUT #InfFile, Temp$
   IF LEFT$(LCASE$(LTRIM$(Temp$)), SFL) = SearchFor$ THEN
      ReadINFFile$ = LTRIM$(MID$(Temp$, INSTR(SFL, Temp$, "=") + 1))
      CLOSE #InfFile
      EXIT FUNCTION
   END IF
LOOP UNTIL NOT EOF(InfFile)
CLOSE #InfFile
END FUNCTION

REM $DYNAMIC
SUB RunGui
MouseChanged = False
Future.UpdateMouse
OldMouseX = MouseX
OldMouseY = MouseY
MouseX = Future.MouseX
MouseY = Future.MouseY
MouseB = Future.MouseB
IF OldMouseX <> MouseX OR OldMouseY <> MouseY THEN
   MouseChanged = True
END IF
IF MouseB > 0 THEN
   IF Process = 0 THEN
      MouseOnWin = DetectWin
      IF MouseOnWin <> ActiveWin THEN SetActiveWin MouseOnWin
      IF MouseOnWin > 0 THEN
         IF MouseOnWinY < 19 THEN
            Process = 2
            ProcessID = ActiveWin
            MoveTemp1 = AllocateXMS(SizeOf(Win(ActiveWin).XSize, 1))
            MoveTemp2 = AllocateXMS(SizeOf(Win(ActiveWin).YSize, 1))
            MoveTemp3 = AllocateXMS(SizeOf(Win(ActiveWin).XSize, 1))
            MoveTemp4 = AllocateXMS(SizeOf(Win(ActiveWin).YSize, 1))
            MoveTempX = MouseX - MouseOnWinX
            MoveTempY = MouseY - MouseOnWinY
            MoveTempX1 = MoveTempX + Win(ProcessID).XSize
            MoveTempY1 = MoveTempY + Win(ProcessID).YSize
            Future.MouseOFF
               Future.XMSget Win(ActiveWin).Xpos + 2, Win(ActiveWin).Ypos + 19, Win(ActiveWin).X1pos - 2, Win(ActiveWin).Y1pos - 2, Win(ActiveWin).Mask
               Future.XMSget MoveTempX, MoveTempY, MoveTempX1, MoveTempY, MoveTemp1
               Future.XMSget MoveTempX1, MoveTempY, MoveTempX1, MoveTempY1, MoveTemp2
               Future.XMSget MoveTempX, MoveTempY1, MoveTempX1, MoveTempY1, MoveTemp3
               Future.XMSget MoveTempX, MoveTempY, MoveTempX, MoveTempY1, MoveTemp4
            Future.MouseON
         ELSE
            FOR ObjectSearch = 1 TO NofO
               IF Object(ObjectSearch).WinID = ActiveWin THEN
                  IF MouseOnWinX > Object(ObjectSearch).Xpos THEN
                     IF MouseOnWinX < Object(ObjectSearch).X1pos THEN
                        IF MouseOnWinY > Object(ObjectSearch).Ypos THEN
                           IF MouseOnWinY < Object(ObjectSearch).Y1pos THEN
                              ObjectID = ObjectSearch
                              EXIT FOR
                           END IF
                        END IF
                     END IF
                  END IF
               END IF
            NEXT
            IF ObjectID > 0 THEN
               SELECT CASE Object(ObjectID).Type
               CASE 1
                  Process = 3
                  ProcessTemp = Process
                  ProcessID = Object(ObjectID).ObjectID
                  ProcessTempID = ProcessID
                  Button(ProcessID).Status = 2
                  Draw.Button ProcessID, ActiveWin
               END SELECT
            END IF
         END IF
      END IF
   END IF
END IF
IF Process > 0 THEN
   SELECT CASE Process
   CASE 1 'View Wrk Page
      ChangePage
      Future.MouseON
      Process = 0
   CASE 2 'Move window
      IF MouseB > 0 AND MouseChanged THEN
         'Future.MouseOFF
            MoveColor& = RGB2Color(200, 200, 200)
            Future.XMSPUT MoveTempX, MoveTempY, MoveTemp1
            Future.XMSPUT MoveTempX1, MoveTempY, MoveTemp2
            Future.XMSPUT MoveTempX, MoveTempY1, MoveTemp3
            Future.XMSPUT MoveTempX, MoveTempY, MoveTemp4
            MoveTempX = MouseX - MouseOnWinX
            MoveTempY = MouseY - MouseOnWinY
            MoveTempX1 = MoveTempX + Win(ProcessID).XSize
            MoveTempY1 = MoveTempY + Win(ProcessID).YSize
            Future.XMSget MoveTempX, MoveTempY, MoveTempX1, MoveTempY, MoveTemp1
            Future.XMSget MoveTempX1, MoveTempY, MoveTempX1, MoveTempY1, MoveTemp2
            Future.XMSget MoveTempX, MoveTempY1, MoveTempX1, MoveTempY1, MoveTemp3
            Future.XMSget MoveTempX, MoveTempY, MoveTempX, MoveTempY1, MoveTemp4
            Future.Line MoveTempX%, MoveTempY, MoveTempX1, MoveTempY, MoveColor&, &HAAAA
            Future.Line MoveTempX%, MoveTempY, MoveTempX%, MoveTempY1, MoveColor&, &HAAAA
            Future.Line MoveTempX%, MoveTempY1, MoveTempX1, MoveTempY1, MoveColor&, &HAAAA
            Future.Line MoveTempX1, MoveTempY, MoveTempX1, MoveTempY1, MoveColor&, &HAAAA
         'Future.MouseON
       END IF
       IF MouseB = 0 THEN
         Future.MouseOFF
            DeallocateXMS MoveTemp1
            DeallocateXMS MoveTemp2
            DeallocateXMS MoveTemp3
            DeallocateXMS MoveTemp4
            Win(ProcessID).Xpos = MoveTempX
            Win(ProcessID).Ypos = MoveTempY
            Win(ProcessID).X1pos = MoveTempX1
            Win(ProcessID).Y1pos = MoveTempY1
            Process = 1
            ProcessID = 0
            SetPage WrkPage
            Future.XMSPUT 0, 0, DesktopMask
            FOR PutWindowCount = 1 TO WinCount - 1
               WinID = WinOrder(PutWindowCount)
               Draw.Window Win(WinID).Xpos, Win(WinID).Ypos, Win(WinID).X1pos, Win(WinID).Y1pos, RTRIM$(Win(WinID).Caption), 2
               Future.XMSPUT Win(WinID).Xpos + 2, Win(WinID).Ypos + 19, Win(WinID).Mask
            NEXT
            WinID = WinOrder(WinCount)
            Draw.Window Win(WinID).Xpos, Win(WinID).Ypos, Win(WinID).X1pos, Win(WinID).Y1pos, RTRIM$(Win(WinID).Caption), 3
            Future.XMSPUT Win(WinID).Xpos + 2, Win(WinID).Ypos + 19, Win(WinID).Mask
         Future.MouseON
      END IF
   CASE 3 'Manage button
      IF MouseB = 0 THEN
         Process = 4
         Button(ProcessID).Status = 1
         Draw.Button ProcessID, ActiveWin
         Button(ProcessID).Status = 3
      END IF
   CASE 4 'Button is released
      Button(ProcessID).Status = 1
      ProcessTempID = ProcessID
      ProcessTemp = Process
      Process = 0
      ProcessID = 0
   END SELECT
END IF
END SUB

REM $STATIC
SUB RunScript
FOR ActiveScript = 1 TO ScriptCount
   IF RunScriptNr > 0 THEN ActiveScript = RunScriptNr
   IF Script(ActiveScript).Status = True THEN
      Argument = 1
      SemiColon = 0
      ReadPoint = SEEK(ActiveScript)
      LINE INPUT #ActiveScript, cmdLine$
      IF LEFT$(cmdLine$, 3) <> "rem" AND cmdLine$ > "" THEN
         Parse

         SELECT CASE Cmd(1)
'BEEP------------------------
         CASE "beep"
            BEEP

'CASE------------------------
         CASE "case"
            JumpToNext "end select"

'CLS-------------------------
         CASE "cls"
            CLS

'COLOR-----------------------
         CASE "color"
            IF (NOT Initalised) THEN
               Script(ActiveScript).TextFCol = GetInteger(2, 2)
               Script(ActiveScript).TextBCol = GetInteger(3, 3)
            ELSE
               IF Cmd(2) = "rgb" THEN
                  Script(ActiveScript).TextFCol& = RGB2Color(GetInteger(3, 3), GetInteger(4, 4), GetInteger(5, 5))
                  Cont = 6
               ELSE
                  Script(ActiveScript).TextFCol& = GetColor(GetInteger(2, 2))
                  Cont = 3
               END IF
               IF Cmd(Cont) = "rgb" THEN
                  Script(ActiveScript).TextBCol& = RGB2Color(GetInteger(Cont + 1, Cont + 1), GetInteger(Cont + 2, Cont + 2), GetInteger(Cont + 3, Cont + 3))
               ELSE
                  Script(ActiveScript).TextBCol& = GetColor(GetInteger(Cont, Cont))
               END IF
           END IF


'DEF SEG---------------------
         CASE "def"
            IF Cmd(2) = "seg" THEN
               IF Argument > 2 THEN
                  TempSegment = GetInteger(4, Argument)
                  DEF SEG = TempSegment
               ELSE
                  TempSegment = 0
                  DEF SEG
               END IF
            END IF

'DO--------------------------
         CASE "do"
            TempVal4 = Script(ActiveScript).ReturnCount
            TempVal5 = Script(ActiveScript).ReturnPoint(TempVal4)
            IF TempVal5 <> ReadPoint THEN
               TempVal4 = TempVal4 + 1
               TempVal5 = ReadPoint
               Script(ActiveScript).ReturnCount = TempVal4
               Script(ActiveScript).ReturnPoint(TempVal4) = TempVal5
               TempVal1 = TempVal2
            END IF

'DRAW (Gui specific)---------
         CASE "draw"
            Future.MouseOFF
            SELECT CASE Cmd(2)
            CASE "box"
               Xpos = GetInteger(3, 3) + Win(ActiveWin).Xpos
               Ypos = GetInteger(4, 4) + Win(ActiveWin).Ypos
               X1pos = GetInteger(5, 5) + Win(ActiveWin).Xpos
               Y1pos = GetInteger(6, 6) + Win(ActiveWin).Ypos
               IF Cmd(7) = "rgb" THEN
                  Col& = RGB2Color(GetInteger(8, 8), GetInteger(9, 9), GetInteger(10, 10))
               ELSE
                  Col& = GetColor(GetInteger(7, 7))
               END IF
               Future.Box Xpos, Ypos, X1pos, Y1pos, Col&
            CASE "fillbox"
               Xpos = GetInteger(3, 3) + Win(ActiveWin).Xpos
               Ypos = GetInteger(4, 4) + Win(ActiveWin).Ypos
               X1pos = GetInteger(5, 5) + Win(ActiveWin).Xpos
               Y1pos = GetInteger(6, 6) + Win(ActiveWin).Ypos
               IF Cmd(7) = "rgb" THEN
                  Col& = RGB2Color(GetInteger(8, 8), GetInteger(9, 9), GetInteger(10, 10))
               ELSE
                  Col& = GetColor(GetInteger(7, 7))
               END IF
               Future.FillBox Xpos, Ypos, X1pos, Y1pos, Col&
            END SELECT
            Future.MouseON
'END-------------------------
         CASE "end"
            IF Argument = 1 THEN
               Script(ActiveScript).Status = False
               CLOSE #ActiveScript
               KILL "Temp\temp" + (LTRIM$(STR$(ActiveScript))) + ".tmp"
            END IF

'EXIT------------------------
         CASE "exit"
            SELECT CASE Cmd(2)
            CASE "for"
               Script(ActiveScript).ReturnCount = Script(ActiveScript).ReturnCount - 1
               JumpToNext ("next")'
            CASE "do"
               Script(ActiveScript).ReturnCount = Script(ActiveScript).ReturnCount - 1
               JumpToNext ("loop")'
            CASE "gui"
               CloseGui
            END SELECT

'FOR-------------------------
         CASE "for"
            TempVal1 = GetIntValue(Cmd(2))
            TempVal2 = GetInteger(4, 4)
            TempVal3 = GetInteger(6, 6)
            TempVal4 = Script(ActiveScript).ReturnCount
            TempVal5 = Script(ActiveScript).ReturnPoint(TempVal4)
            IF TempVal5 <> ReadPoint THEN
               TempVal4 = TempVal4 + 1
               TempVal5 = ReadPoint
               Script(ActiveScript).ReturnCount = TempVal4
               Script(ActiveScript).ReturnPoint(TempVal4) = TempVal5
               TempVal1 = TempVal2
            END IF
            IF Argument = 8 THEN
               TempVal6 = GetInteger(8, 8)
               TempVal1 = TempVal1 + TempVal6
               IF TempVal6 < 0 THEN
                  StepDir = -1
               END IF
            ELSE
               TempVal1 = TempVal1 + 1
            END IF
            IF StepDir = 0 AND TempVal1 > TempVal3 OR StepDir = -1 AND TempVal1 < TempVal3 THEN
               JumpToNext "next"
               Script(ActiveScript).ReturnCount = Script(ActiveScript).ReturnCount - 1
            END IF
            SetInteger Cmd(2), TempVal1

'GET (Gui Speific)-----------
         CASE "get"
            SELECT CASE Cmd(4)
            CASE "active"
               IF Cmd(5) = "window" THEN
                  SetInteger Cmd(2), GetInteger(6, 6)
               END IF
            END SELECT

'IF...THEN-------------------
         CASE "if"
            CheckType$ = RIGHT$(Cmd(2), 1)
            SELECT CASE CheckType$
            CASE CHR$(34), "$"
               Arg1$ = GetString$(2, 2)
               Arg2$ = GetString$(4, 4)
               Action$ = Cmd(3)
               SELECT CASE Action$
               CASE "="
                  IF Arg1$ <> Arg2$ THEN JumpToNext "end if"
               CASE "<"
                  IF Arg1$ >= Arg2$ THEN JumpToNext "end if"
               CASE ">"
                  IF Arg1$ <= Arg2$ THEN JumpToNext "end if"
               CASE "<="
                  IF Arg1$ > Arg2$ THEN JumpToNext "end if"
               CASE ">="
                  IF Arg1$ < Arg2$ THEN JumpToNext "end if"
               CASE "<>"
                  IF Arg1$ <> Arg2$ THEN JumpToNext "end if"
               END SELECT
            CASE CHR$(48) TO CHR$(57), "%"
               Arg1 = GetInteger(2, 2)
               Arg2 = GetInteger(4, 4)
               Action$ = Cmd(3)
               SELECT CASE Action$
               CASE "="
                  IF Arg1 <> Arg2 THEN JumpToNext "end if"
               CASE "<"
                  IF Arg1 >= Arg2 THEN JumpToNext "end if"
               CASE ">"
                  IF Arg1 <= Arg2 THEN JumpToNext "end if"
               CASE "<="
                  IF Arg1 > Arg2 THEN JumpToNext "end if"
               CASE ">="
                  IF Arg1 < Arg2 THEN JumpToNext "end if"
               CASE "<>"
                  IF Arg1 <> Arg2 THEN JumpToNext "end if"
               END SELECT
            END SELECT

'INIT (Gui specific)---------
         CASE "init"
            SELECT CASE Cmd(2)
            CASE "gui"
               InitGui GetInteger(3, 3), GetInteger(4, 4), GetInteger(5, 5)
               Future.CLS 0
               Future.XMSget 1, 1, Xres, Yres, DesktopMask
            END SELECT

'LET-------------------------
         CASE "let"
            CheckType$ = RIGHT$(Cmd(2), 1)
            SELECT CASE CheckType$
            CASE "$"
               SetString Cmd(2), GetString$(4, Argument)
            CASE "%"
               SetInteger Cmd(2), GetInteger(4, Argument)
            CASE "#"
               SetDouble Cmd(2), GetDouble(4, Argument)
            END SELECT

'LOCATE----------------------
         CASE "locate"
            IF Initalised THEN
               Script(ActiveScript).TextXLoc = ABS(GetInteger(2, 2))
               Script(ActiveScript).TextYLoc = ABS(GetInteger(3, 3))
            ELSE
               LOCATE GetInteger(2, 2), GetInteger(3, 3)
            END IF

'LOOP------------------------
         CASE "loop"
            IF Argument > 1 THEN
               CheckType$ = RIGHT$(Cmd(3), 1)
               SELECT CASE CheckType$
               CASE "$"
                  Cond1$ = GetString$(3, MarkPos - 1)
                  Cond2$ = GetString$(MarkPos + 1, Argument)
                  SELECT CASE Cmd(MarkPos)
                  CASE ">"
                     IF Cond1$ > Cond2$ THEN
                        DontReturn = True
                     END IF
                  CASE "<"
                     IF Cond1$ < Cond2$ THEN
                        DontReturn = True
                     END IF
                  CASE "<="
                     IF Cond1$ <= Cond2$ THEN
                        DontReturn = True
                     END IF
                  CASE ">="
                     IF Cond1$ >= Cond2$ THEN
                        DontReturn = True
                     END IF
                  CASE "<>"
                     IF Cond1$ <> Cond2$ THEN
                        DontReturn = True
                     END IF
                  CASE "="
                     IF Cond1$ = Cond2$ THEN
                        DontReturn = True
                     END IF
                  END SELECT
               CASE ELSE
                  Cond1 = GetInteger(3, MarkPos - 1)
                  Cond2 = GetInteger(MarkPos + 1, Argument)
                  SELECT CASE Cmd(MarkPos)
                  CASE ">"
                     IF Cond1 > Cond2 THEN
                        DontReturn = True
                     END IF
                  CASE ">="
                     IF Cond1 >= Cond2 THEN
                        DontReturn = True
                     END IF
                  CASE "<="
                     IF Cond1 <= Cond2 THEN
                        DontReturn = True
                     END IF
                  CASE "<"
                     IF Cond1 < Cond2 THEN
                        DontReturn = True
                     END IF
                  CASE "<>"
                     IF Cond1 <> Cond2 THEN
                        DontReturn = True
                     END IF
                  CASE "="
                     IF Cond1 = Cond2 THEN
                        DontReturn = True
                     END IF
                  END SELECT
               END SELECT
            END IF
            IF DontReturn = False THEN
               SEEK #ActiveScript, Script(ActiveScript).ReturnPoint(Script(ActiveScript).ReturnCount)
            ELSE
               Script(ActiveScript).ReturnCount = Script(ActiveScript).ReturnCount - 1
            END IF

'NEXT------------------------
         CASE "next"
            SEEK #ActiveScript, Script(ActiveScript).ReturnPoint(Script(ActiveScript).ReturnCount)

'OPEN------------------------
         CASE "open"
            SELECT CASE Cmd(4)
               CASE "script"
                  Proc = LoadScript(GetString$(2, Argument))
               END SELECT

'OUT-------------------------
         CASE "out"
            OUT GetInteger(2, 2), GetInteger(3, 3)

'POKE------------------------
         CASE "poke"
            POKE GetInteger(2, 2), GetInteger(3, 3)

'PRINT-----------------------
         CASE "print"
            CheckType$ = RIGHT$(Cmd(2), 1)
            SELECT CASE CheckType$
            CASE CHR$(34), "$"
               PrintTemp$ = GetString$(2, Argument)
            CASE ELSE
               PrintTemp$ = STR$(GetInteger(2, Argument))
            END SELECT
            IF Initalised = False THEN
               COLOR INT(Script(ActiveScript).TextFCol), INT(Script(ActiveScript).TextBCol)
               IF SemiColon = True THEN
                  PRINT PrintTemp$;
               ELSE
                  PRINT PrintTemp$
               END IF
            ELSE
               TextX = Win(ActiveWin).Xpos + Script(ActiveScript).TextXLoc
               TextY = Win(ActiveWin).Ypos + Script(ActiveScript).TextYLoc
               TextFC& = Script(ActiveScript).TextFCol
               TextBC& = Script(ActiveScript).TextBCol
               Future.Print TextX, TextY, PrintTemp$, TextFC&, TextBC&
            END IF

'RANDOMIZE (TIMER)-----------
         CASE "randomize"
            IF Argument > 1 THEN
               IF Cmd(2) = "timer" THEN
                  RANDOMIZE TIMER
               ELSE
                  RANDOMIZE GetInteger(3, Argument)
               END IF
            END IF

'RESET (Gui raleted)---------
         CASE "reset"
            SELECT CASE Cmd(2)
            CASE "event"
               ProcessTemp = 0
               ProcessTempID = 0
            END SELECT

'SELECT CASE-----------------
         CASE "select"
            CheckType$ = RIGHT$(Cmd(3), 1)
            SELECT CASE CheckType$
            CASE CHR$(34), "$"
               Temp$ = GetString$(3, Argument)
               DO
                  LINE INPUT #ActiveScript, cmdLine$
                  cmdLine$ = RTRIM$(LTRIM$(LCASE$(cmdLine$)))
                  IF LEFT$(cmdLine$, 6) = "select" THEN JumpToNext "end select"
                  IF LEFT$(cmdLine$, 10) = "end select" THEN EXIT DO
                  IF LEFT$(cmdLine$, 4) = "case" THEN
                     Argument = 1
                     Parse
                     IF Cmd(2) = "else" THEN EXIT DO
                     FOR CaseCount = 2 TO Argument
                        SELECT CASE Cmd(CaseCount)
                        CASE "is"
                           SELECT CASE Cmd(CaseCount + 1)
                           CASE "="
                              IF Temp$ = GetString$(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE ">"
                              IF Temp$ > GetString$(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE "<"
                              IF Temp$ < GetString$(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE ">="
                              IF Temp$ >= GetString$(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE "<="
                              IF Temp$ <= GetString$(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE "<>"
                              IF Temp$ <> GetString$(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           END SELECT
                           CaseCount = CaseCount + 2
                        CASE ELSE
                           IF Temp$ = GetString$(CaseCount, CaseCount) THEN EXIT DO
                        END SELECT
                     NEXT
                  END IF
               LOOP
            CASE ELSE
               Temp = GetInteger(3, Argument)
               DO
                  LINE INPUT #ActiveScript, cmdLine$
                  cmdLine$ = RTRIM$(LTRIM$(LCASE$(cmdLine$)))
                  IF LEFT$(cmdLine$, 6) = "select" THEN JumpToNext "end select"
                  IF LEFT$(cmdLine$, 10) = "end select" THEN EXIT DO
                  IF LEFT$(cmdLine$, 4) = "case" THEN
                     Argument = 1
                     Parse
                     IF Cmd(2) = "else" THEN EXIT DO
                     FOR CaseCount = 2 TO Argument
                        SELECT CASE Cmd(CaseCount)
                        CASE "is"
                           SELECT CASE Cmd(CaseCount + 1)
                           CASE "="
                              IF Temp = GetInteger(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE ">"
                              IF Temp > GetInteger(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE "<"
                              IF Temp < GetInteger(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE ">="
                              IF Temp >= GetInteger(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE "<="
                              IF Temp <= GetInteger(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           CASE "<>"
                              IF Temp <> GetInteger(CaseCount + 2, CaseCount + 2) THEN EXIT DO
                           END SELECT
                           CaseCount = CaseCount + 2
                        CASE ELSE
                           IF Temp = GetInteger(CaseCount, CaseCount) THEN EXIT DO
                        END SELECT
                     NEXT
                  END IF
               LOOP
            END SELECT

'SET (Gui specific)---------
         CASE "set"
            SELECT CASE Cmd(2)
            CASE "active"
               SELECT CASE Cmd(3)
               CASE "window"
                  SetActiveWin GetInteger(4, 4)
               END SELECT
            CASE "background"
               Future.MouseOFF
               SELECT CASE Cmd(3)
               CASE "image"
                  FileName$ = GetString$(4, 4)
                  DIM FileInfo AS TfileInfoExt
                  GetBMPinfo FileName$, FileInfo
                  ImgXpos = 1
                  ImgYpos = 1
                  IF Argument > 4 THEN
                     SELECT CASE Cmd(5)
                     CASE "stretch"
                        SetScale 1
                        SetScalesize Xres, Yres
                     CASE "center"
                        ImgXpos = (Xres / 2) - (FileInfo.FileXres / 2)
                        ImgYpos = (Yres / 2) - (FileInfo.FileYres / 2)
                     END SELECT
                  END IF
                  Future.LoadBMP.ext FileName$, ImgXpos, ImgYpos
                  SetScale 0
               CASE "color"
                  IF Cmd(4) = "rgb" THEN
                     Future.CLS RGB2Color(GetInteger(5, 5), GetInteger(6, 6), GetInteger(7, 7))
                  ELSE
                  Future.CLS GetColor(GetInteger(4, 4))
                  END IF
               END SELECT
               Future.XMSget 1, 1, Xres, Yres, DesktopMask
               Future.MouseON
            CASE "window"
               WinXpos = GetInteger(5, 5)
               WinYpos = GetInteger(6, 6)
               WinXSize = GetInteger(7, 7)
               WinYSize = GetInteger(8, 8)
               WinName$ = GetString(9, 9)
               SetInteger Cmd(3), New.Window(WinXpos, WinYpos, WinXSize, WinYSize, WinName$)
            CASE "button"
               ButXpos = GetInteger(5, 5)
               ButYpos = GetInteger(6, 6)
               ButXSize = GetInteger(7, 7)
               ButYSize = 20'GetInteger(8, 8)
               ButStyle = GetInteger(9, 9)
               ButWinID = GetInteger(10, 10)
               ButName$ = GetString(11, 11)
               SetInteger Cmd(3), New.Button(ButXpos, ButYpos, ButXSize, ButYSize, ButName$, ButStyle, ButWinID)
            END SELECT
'SLEEP-----------------------
         CASE "sleep"
            IF LEN(INKEY$) = 0 THEN SEEK #ActiveScript, ReadPoint

'SYSTEM----------------------
         CASE "system"
            CLOSE
            RESET
            FOR i = 1 TO ScriptCount
               IF Script(i).Status = True THEN
                  KILL "Temp\temp" + (LTRIM$(STR$(i))) + ".tmp"
               END IF
            NEXT
            a! = SETMEM(6400000)
            END

'WAIT------------------------
         CASE "wait"
            SELECT CASE Argument
            CASE 3
               WAIT GetInteger(2, 2), GetInteger(3, 3)
            CASE 4
               WAIT GetInteger(2, 2), GetInteger(3, 3), GetInteger(4, 4)
            END SELECT

'(Case else)?----------------
         CASE ELSE
            IF Cmd(2) = "=" THEN
               CheckType$ = RIGHT$(Cmd(1), 1)
               SELECT CASE CheckType$
               CASE "$"
                  SetString Cmd(1), GetString$(3, Argument)
               CASE "%"
                  SetInteger Cmd(1), GetInteger(3, Argument)
               CASE "#"
                  SetDouble Cmd(1), GetDouble(3, Argument)
               END SELECT
            END IF
         END SELECT
      END IF
   ELSE
      RunScriptNr = 0
   END IF
NEXT
END SUB

SUB SetActiveWin (WinID%)
Future.MouseOFF
IF ActiveWin > 0 THEN
   Check = ActiveWin
   ActiveWin = 0
   Win(Check).Status = 1
   Future.XMSget Win(Check).Xpos + 2, Win(Check).Ypos + 19, Win(Check).X1pos - 2, Win(Check).Y1pos - 2, Win(Check).Mask
   Draw.Window Win(Check).Xpos, Win(Check).Ypos, Win(Check).X1pos, Win(Check).Y1pos, RTRIM$(Win(Check).Caption), 2
END IF

IF WinID = 0 THEN
   ActiveWin = 0
   Future.MouseON
   EXIT SUB
END IF

ActiveWin = WinID
Draw.Window Win(ActiveWin).Xpos, Win(ActiveWin).Ypos, Win(ActiveWin).X1pos, Win(ActiveWin).Y1pos, RTRIM$(Win(ActiveWin).Caption), 3
Future.XMSPUT Win(ActiveWin).Xpos + 2, Win(ActiveWin).Ypos + 19, Win(ActiveWin).Mask
Win(WinID).Status = 2
Future.MouseON
IF WinCount = 1 THEN EXIT SUB

FOR Check = 1 TO WinCount
   IF WinOrder(Check) = WinID THEN EXIT FOR
NEXT Check
FOR Check = Check TO WinCount - 1
   SWAP WinOrder(Check), WinOrder(Check + 1)
NEXT Check
END SUB

SUB SetDouble (DoubleName$, BYVAL Value AS DOUBLE)
'Set's value to Double type variable
FOR VarSearch = 1 TO DoubleCount
   IF DblVar(VarSearch).ScriptID = ActiveScript THEN
      IF DoubleName$ = RTRIM$(DblVar(VarSearch).Name) THEN
         DblVar(VarSearch).Value = Value
         EXIT SUB
      END IF
    END IF
NEXT VarSearch
DoubleCount = DoubleCount + 1
REDIM PRESERVE DblVar(DoubleCount) AS DoubleVariables
DblVar(DoubleCount).Name = DoubleName$
DblVar(DoubleCount).Value = Value
DblVar(DoubleCount).ScriptID = ActiveScript
END SUB

SUB SetInteger (IntegerName$, BYVAL Value AS INTEGER)
'Set's value to integer type variable
FOR VarSearch = 1 TO IntegerCount
   IF IntVar(VarSearch).ScriptID = ActiveScript THEN
      IF IntegerName$ = RTRIM$(IntVar(VarSearch).Name) THEN
         IntVar(VarSearch).Value = Value
         EXIT SUB
      ELSE
         IF RTRIM$(IntVar(VarSearch).Name) = "" THEN FreeSlot = VarSearch
      END IF
    END IF
NEXT VarSearch
IF FreeSlot = 0 THEN
   IntegerCount = IntegerCount + 1
   Slot = IntegerCount
   REDIM PRESERVE IntVar(Slot) AS IntegerVariables
END IF
IntVar(Slot).Name = IntegerName$
IntVar(Slot).Value = Value
IntVar(Slot).ScriptID = ActiveScript
END SUB

SUB SetString (StringName$, Value$)
'Set's value to String type variable
FOR VarSearch = 1 TO StringCount
   IF StrVar(VarSearch).ScriptID = ActiveScript THEN
      IF StringName$ = RTRIM$(StrVar(VarSearch).Name) THEN
         StrVal(VarSearch) = Value$
         EXIT SUB
      END IF
   END IF
NEXT VarSearch
StringCount = StringCount + 1
REDIM PRESERVE StrVar(StringCount)  AS StringVariables
REDIM PRESERVE StrVal(StringCount)  AS STRING
StrVar(StringCount).Name = StringName$
StrVal(StringCount) = Value$
StrVar(StringCount).ScriptID = ActiveScript
END SUB

